/*
 *  linux/arch/arm/mach-mb86hxx/gpio.c
 *
 * Copyright (C) 2010 FUJITSU MICROELECTRONICS LIMITED
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <linux/io.h>
#include <linux/platform_device.h>
#include <mach/hardware.h>
#include <mach/gpio.h>


char *mb86h6x_hsmmc_clksrcs[4] = {
	[0] = "mb86hxx-sdio",
//	[1] = "mb86hxx-sdio",
//	[2] = "mmc_bus",
};

int mb86h6X_gpio_config_out(int gpio, int function)
{
	void __iomem *reg;

	reg = (void *)(MB86HXX_GPIO_VA_BASE + GPIO_CONFIG_DATAOUT + gpio*4);
	__raw_writel(function, reg);
	return 0;
}

int mb86h6X_gpio_config_in(int gpio, int function)
{
	void __iomem *reg;

	reg = (void *)(MB86HXX_GPIO_VA_BASE + GPIO_CONFIG_DATAIN + function*4);
	__raw_writel(gpio + 2, reg);
	return 0;
}

void mb86h6x_setup_sdhci0_cfg_gpio(struct platform_device *dev, int width)
{
       mb86h6X_gpio_config_out(0,0);

       mb86h6X_gpio_config_in(SDIO_PIN_DATA0,GPIO_FUNCTION_IN_SDIO_DATA_0); 
       mb86h6X_gpio_config_out(SDIO_PIN_DATA0,GPIO_FUNCTION_OUT_SDIO_DATA_0+(13<<8));

       mb86h6X_gpio_config_in(SDIO_PIN_DATA1,GPIO_FUNCTION_IN_SDIO_DATA_1); 
       mb86h6X_gpio_config_out(SDIO_PIN_DATA1,GPIO_FUNCTION_OUT_SDIO_DATA_1+(14<<8));

       mb86h6X_gpio_config_in(SDIO_PIN_DATA2,GPIO_FUNCTION_IN_SDIO_DATA_2);
       mb86h6X_gpio_config_out(SDIO_PIN_DATA2,GPIO_FUNCTION_OUT_SDIO_DATA_2+(15<<8));
       
       mb86h6X_gpio_config_in(SDIO_PIN_DATA3,GPIO_FUNCTION_IN_SDIO_DATA_3);  
       mb86h6X_gpio_config_out(SDIO_PIN_DATA3,GPIO_FUNCTION_OUT_SDIO_DATA_3+(16<<8));


       mb86h6X_gpio_config_in(SDIO_PIN_CMD,GPIO_FUNCTION_IN_SDIO_CMD);  
       mb86h6X_gpio_config_out(SDIO_PIN_CMD,GPIO_FUNCTION_OUT_SDIO_CMD+(12<<8)); 

       mb86h6X_gpio_config_out(SDIO_PIN_CLK,GPIO_FUNCTION_SDIO_OUT_CLK); 

       mb86h6X_gpio_config_in(SDIO_PIN_CD,GPIO_FUNCTION_SDIO_IN_XSDCD);  

}

void mb86h6x_setup_sdhci_cfg_card(struct platform_device *dev,
				  void __iomem *r,
				  struct mmc_ios *ios,
				  struct mmc_card *card)
{

}

