/*
 * arch/arm/mach-mb86hxx/include/mach/mb86hxx.h
 *
 * Copyright (C) 2008-2010 FUJITSU MICROELECTRONICS LIMITED
 * Copyright (C) 2010-2011 FUJITSU SEMICONDUCTOR LIMITED
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef __ARCH_ARM_MACH_MB86HXX_H
#define __ARCH_ARM_MACH_MB86HXX_H

/* Clocks */
#if defined(CONFIG_MACH_FUJITSU_TVSTBSOC)
#define MB86HXX_CPU_HZ		324000000		/* Core    */
#define MB86HXX_AXI_HZ		162000000		/* AXI/AHB */
#define MB86HXX_AVH_HZ		216000000		/* AV High */
#define MB86HXX_HDMIH_HZ	 74250000		/* HDMI Hi */
#elif defined(CONFIG_MACH_FUJITSU_TVSTBSOC1)
#define MB86HXX_CPU_HZ		396000000		/* Core    */
#define MB86HXX_AXI_HZ		198000000		/* AXI/AHB */
#define MB86HXX_AVH_HZ		198000000		/* AV High */
#define MB86HXX_HDMIH_HZ	148500000		/* HDMI Hi */
#endif

#define MB86HXX_APB_HZ		(MB86HXX_AXI_HZ / 2)	/* APB     */
#define MB86HXX_AVM_HZ		(MB86HXX_AVH_HZ / 4)	/* AV Mid  */
#define MB86HXX_AVL_HZ		(MB86HXX_AVH_HZ / 8)	/* AV Low  */

/* Memory Map */
#define MB86HXX_BOOTROM_BASE	0x00000000
#define MB86HXX_SRAM_BASE	0x02000000
#define MB86HXX_DDR1_BASE	0x20000000
#ifdef CONFIG_MB86HXX_LARGEMEM
#if (CONFIG_MEM_SIZE_RAMIFS != 0)
#define MB86HXX_BUF_BASE	MB86HXX_DDR1_BASE
#else
#define MB86HXX_BUF_BASE	0x40000000
#endif
#else
#define MB86HXX_BUF_BASE	(MB86HXX_DDR1_BASE + CONFIG_MEM_SIZE_RAMIFS)
#endif /* CONFIG_MB86HXX_LARGEMEM */

#if defined(CONFIG_MACH_FUJITSU_TVSTBSOC)
#define MB86HXX_UART0_BASE  	0xC2000000
#define MB86HXX_I2C0_BASE	0xC4000000
#define MB86HXX_SSP0_BASE	0xD1000000
#define MB86HXX_SSP1_BASE	0xD4000000
#define MB86HXX_EFUSE_BASE	0xD5000000
#define MB86HXX_ETH_BASE	0xE4000000
#elif defined(CONFIG_MACH_FUJITSU_TVSTBSOC1)
/* new module for H61*/
#define MB86HXX_IR_BASE     	0xC2000000
#define MB86HXX_EFUSE_BASE	0xC4000000
#define MB86HXX_R2R_BASE    	0xC6000000
#define MB86HXX_USBPHY0_BASE	0xC7001000
#define MB86HXX_USBPHY1_BASE	0xC7003000
#define MB86HXX_CEC_BASE    	0xC9000000
#define MB86HXX_UART0_BASE  	0xCD000000
#define MB86HXX_HDMI_BASE   	0xD0000000
#define MB86HXX_I2C0_BASE   	0xD1000000
#define MB86HXX_SSP0_BASE   	0xD4000000
#define MB86HXX_SSP1_BASE	0xD5000000
#define MB86HXX_GRAPHENG_BASE   0xD6000000
#define MB86HXX_ADC_BASE    	0xD7000000
#define MB86HXX_AXICFG_BASE 	0xDC000000
#define MB86HXX_ETH_BASE	0xE2000000
#define MB86HXX_SATA_BASE   	0xE4000000
#define MB86HXX_HDMAC_BASE  	0xE6000000
#define MB86HXX_NAND_BASE   	0xE8000000
#define MB86HXX_NANDCFG_BASE   	0xEA000000
#define MB86HXX_SDIO_BASE   	0xEC000000

#define MB86HXX_SZ_SDIO         0x1000
#endif

#if (CONFIG_MEM_SIZE_RAMIFS != 0)
#define MB86HXX_DDR2_BASE	0x40000000
#else
#define MB86HXX_DDR2_BASE	(0x40000000 + CONFIG_MEM_SIZE_RAMIFV - CONFIG_FIRM_FRAME_BUFFER_SIZE)
#endif
#define MB86HXX_VIDDEC_BASE	0x60000000
#define MB86HXX_PINT_BASE	0x610E2000
#define MB86HXX_UPI_BASE	0x80000000
#define MB86HXX_SFLASH_BASE	0xC0000000
#define MB86HXX_FPCIR_BASE	0xC1000000
#define MB86HXX_GPIO_BASE	0xC3000000
#define MB86HXX_ICC_BASE	0xC5000000
#define MB86HXX_DMA_BASE	0xC7000000
#define MB86HXX_USB_BASE	0xC7000800
#define MB86HXX_TSD_BASE	0xC8000000
#define MB86HXX_CLKPWR_BASE	0xCA000000
#define MB86HXX_VIDOUT_BASE	0xCB000000
#define MB86HXX_AUD_BASE	0xCC000000
#define MB86HXX_UART1_BASE	0xCE000000
#define MB86HXX_TIMER0_BASE	0xCF000000
#define MB86HXX_TIMER1_BASE	0xCF000040
#define MB86HXX_TIMER2_BASE	0xCF000080
#define MB86HXX_IRC_BASE	0xCF000200
#define MB86HXX_I2C1_BASE	0xD2000000
#define MB86HXX_I2C2_BASE	0xD3000000
#define MB86HXX_PIRLO_BASE	0xDB000000
#define MB86HXX_SCHED_BASE	0xDC000000
#define MB86HXX_RAMIFS_BASE	0xDD000000
#define MB86HXX_RAMIFV_BASE	0xDE000000
#define MB86HXX_VIC_BASE	0xE0000000

/* VA Map */
#define MB86HXX_DDR1_VA_BASE	(0xD8000000 - CONFIG_FIRM_AREA_SIZE)
#ifdef CONFIG_MB86HXX_LARGEMEM
#define MB86HXX_BUF_VA_BASE	MB86HXX_DDR1_VA_BASE
#else
#define MB86HXX_BUF_VA_BASE	(0xD8000000 - (PHYS_SIZE - CONFIG_MEM_SIZE_RAMIFS))
#endif /* CONFIG_MB86HXX_LARGEMEM */

#define MB86HXX_DDR2_VA_BASE	0xD8000000

#if defined(CONFIG_MACH_FUJITSU_TVSTBSOC)
#define MB86HXX_UART0_VA_BASE	0xFE902000
#define MB86HXX_I2C0_VA_BASE	0xFE904000
#define MB86HXX_SSP0_VA_BASE	0xFF651000
#define MB86HXX_SSP1_VA_BASE	0xFF654000
#define MB86HXX_EFUSE_VA_BASE	0xFF655000
#define MB86HXX_ETH_VA_BASE	0xFFFE0000
#define MB86HXX_VIC_VA_BASE	0xFFFEF000
#elif defined(CONFIG_MACH_FUJITSU_TVSTBSOC1)
#define MB86HXX_UART0_VA_BASE	0xFF64D000
#define MB86HXX_I2C0_VA_BASE	0xFF651000
#define MB86HXX_SSP0_VA_BASE	0xFF654000
#define MB86HXX_SSP1_VA_BASE	0xFF655000
#define MB86HXX_EFUSE_VA_BASE	0xFE904000
#define MB86HXX_ETH_VA_BASE	0xFFFE2000
#define MB86HXX_SATA_VA_BASE	0xFFFE4000
#define MB86HXX_HDMAC_VA_BASE	0xFFFE6000
#define MB86HXX_NAND_VA_BASE	0xF9800000 //0xFE992000
#define MB86HXX_NANDCFG_VA_BASE	0xFFFEA000
#define MB86HXX_SDIO_VA_BASE	0xFFFEC000
#define MB86HXX_IR_VA_BASE	0xFE902000
#define MB86HXX_R2R_VA_BASE	0xFE906000
#define MB86HXX_USBPHY0_VA_BASE	0xF9001000 //0xFE911000
#define MB86HXX_USBPHY1_VA_BASE	0xF9003000 //0xFE913000
#define MB86HXX_CEC_VA_BASE	0xF9000000 //0xFE990000
#define MB86HXX_HDMI_VA_BASE	0xFF650000
#define MB86HXX_GRAPHENG_VA_BASE   0xFF656000
#define MB86HXX_ADC_VA_BASE	0xFF657000
#define MB86HXX_VIC_VA_BASE	0xFFFE0000
#endif

#define MB86HXX_UPI_VA_BASE	0xE0000000
#define MB86HXX_VIDDEC_VA_BASE	0xF8100000
#define MB86HXX_PINT_VA_BASE    0xF81D2000
#define MB86HXX_BOOTROM_VA_BASE	0xFE8F0000
#define MB86HXX_SRAM_VA_BASE	0xFE8F8000
#define MB86HXX_SFLASH_VA_BASE	0xFE900000
#define MB86HXX_FPCIR_VA_BASE	0xFE901000
#define MB86HXX_GPIO_VA_BASE	0xFE903000
#define MB86HXX_ICC_VA_BASE	0xFE905000
#define MB86HXX_USB_VA_BASE	0xFE906800
#define MB86HXX_DMA_VA_BASE	0xFE907000
#define MB86HXX_TSD_VA_BASE	0xFE908000
#define MB86HXX_CLKPWR_VA_BASE	0xFF60A000
#define MB86HXX_VIDOUT_VA_BASE	0xFF610000
#define MB86HXX_AUD_VA_BASE	0xFF64C000
#define MB86HXX_UART1_VA_BASE	0xFF64E000
#define MB86HXX_TIMER0_VA_BASE	0xFF64F000
#define MB86HXX_TIMER1_VA_BASE	0xFF64F040
#define MB86HXX_TIMER2_VA_BASE	0xFF64F080
#define MB86HXX_IRC_VA_BASE	0xFF64F200
#define MB86HXX_I2C1_VA_BASE	0xFF652000
#define MB86HXX_I2C2_VA_BASE	0xFF653000
#define MB86HXX_PIRLO_VA_BASE	0xFF65B000
#define MB86HXX_SCHED_VA_BASE	0xFF65C000
#define MB86HXX_RAMIFS_VA_BASE	0xFF65D000
#define MB86HXX_RAMIFV_VA_BASE	0xFF65E000

/* IRQ Signal Map */
#define IRQ_RESERVED0			0
#define IRQ_COMMRx			1
#define IRQ_COMMTx			2
#define IRQ_RESERVED3			3
#define IRQ_RESERVED4			4
#define IRQ_TIMER0			5
#define IRQ_TIMER1			6
#define IRQ_TIMER2			7

#if defined(CONFIG_MACH_FUJITSU_TVSTBSOC)
#define IRQ_UART0			8
#define IRQ_UART1			9
#define IRQ_SSP0			10
#define IRQ_SSP1			11
#define IRQ_ICC0			12
#define IRQ_ICC1			13
#define IRQ_FPCIR			14
#define IRQ_I2C0			15
#define IRQ_I2C1			16
#define IRQ_I2C2			17
#else  /* for H61 */
#define IRQ_UART0                       8
#define IRQ_SATA                        9
#define IRQ_SSP0                        10
#define IRQ_BLTE                        11
#define IRQ_ICC0                        12
#define IRQ_SDIO                        13
#define IRQ_FPCIR                       14
#define IRQ_I2C0                        15
#define IRQ_HDMA                        16
#define IRQ_R2R                         17
#endif 
#define IRQ_VIDDEC			18
#define IRQ_GPIO			19
#define IRQ_DMA				20
#define IRQ_USB				21
#define IRQ_ETH				22
#define IRQ_AUD				23

#if defined(CONFIG_MACH_FUJITSU_TVSTBSOC)
#define IRQ_TSDBM01 			24
#define IRQ_TSDBM23			25
#define IRQ_TSD01			26
#define IRQ_TSD23			27
#else
#define IRQ_BM01                        24
#define IRQ_ADC                         25
#define IRQ_TSD01                       26 
#define IRQ_NAND                        27
#endif

#define IRQ_VIDOUT0			28
#define IRQ_VIDOUT1			29
#define IRQ_VIDOUT2			30
#define IRQ_RESERVED31			31

/* IRC */
#define IRC_VA_BASE			MB86HXX_IRC_VA_BASE
#define IRC_ARC_VALID_IRQ_MASK		0x0		/* mask all */
#define IRC_ARM_VALID_IRQ_MASK		0xFFFFFFFF		/* no mask */

/* VIC */
#define VIC_BASE			MB86HXX_VIC_BASE
#define VIC_VA_BASE			MB86HXX_VIC_VA_BASE
#define VIC_VALID_IRQ_MASK		0xFFFFFFFF
				/* all interrupts enabled */

/* Timer */
#define TIMER_HZ			MB86HXX_APB_HZ
#define TIMER_VA_BASE			MB86HXX_TIMER0_VA_BASE
#define IRQMASK_TIMERINT		IRQ_TIMER0

/* UART */
#define UART_HZ				MB86HXX_APB_HZ
#define UART_BASE			MB86HXX_UART0_BASE
#define UART_VA_BASE			MB86HXX_UART0_VA_BASE

/* Ethernet */
#define ETH_MHZ                 	MB86HXX_APB_HZ/1000000
#ifdef CONFIG_MACH_FUJITSU_TVSTBSOC
#define MB86HXX_FMAC3H_WORKAROUND 	1
#endif

#endif				/* __ARCH_ARM_MACH_MB86HXX_H */
