/*
 * linux/arch/arm/mach-mb86hxx/vic.h
 *
 * Copyright (C) 2008-2010 FUJITSU MICROELECTRONICS LIMITED
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef __ASM_ARCH_MB86HXX_VIC_H
#define __ASM_ARCH_MB86HXX_VIC_H

#define VIC_IRQ_STATUS			0x00
#define VIC_FIQ_STATUS			0x04
#define VIC_RAW_STATUS			0x08
#define VIC_INT_SELECT			0x0c
#define VIC_INT_ENABLE			0x10
#define VIC_INT_ENABLE_CLEAR		0x14
#define VIC_INT_SOFT			0x18
#define VIC_INT_SOFT_CLEAR		0x1c
#define VIC_PROTECT			0x20
#define VIC_VECT_ADDR0			0x100
#define VIC_ADDRESS			0xf00

#define VIC_ITCR			0x300

#define IRQ_VECTOR_ADDR			0xffff0018

/* VIC Vector Priority Register */
#define	VIC_PRIO_0 0x200
#define	VIC_PRIO_1 0x204
#define	VIC_PRIO_2 0x208
#define	VIC_PRIO_3 0x20C
#define	VIC_PRIO_4 0x210
#define	VIC_PRIO_5 0x214
#define	VIC_PRIO_6 0x218
#define	VIC_PRIO_7 0x21c
#define	VIC_PRIO_8 0x220
#define	VIC_PRIO_9 0x224
#define	VIC_PRIO_10 0x228
#define	VIC_PRIO_11 0x22c
#define	VIC_PRIO_12 0x230
#define	VIC_PRIO_13 0x234
#define	VIC_PRIO_14 0x238
#define	VIC_PRIO_15 0x23c
#define	VIC_PRIO_16 0x240
#define	VIC_PRIO_17 0x244
#define	VIC_PRIO_18 0x248
#define	VIC_PRIO_19 0x24c
#define	VIC_PRIO_20 0x250
#define	VIC_PRIO_21 0x254
#define	VIC_PRIO_22 0x258
#define	VIC_PRIO_23 0x25c
#define	VIC_PRIO_24 0x260
#define	VIC_PRIO_25 0x264
#define	VIC_PRIO_26 0x268
#define	VIC_PRIO_27 0x26c
#define	VIC_PRIO_28 0x270
#define	VIC_PRIO_29 0x274
#define	VIC_PRIO_30 0x278
#define	VIC_PRIO_31 0x27c

/* Priority */
#define IRQ_PRIO_0                      0xf
#define IRQ_PRIO_1                      0xf
#define IRQ_PRIO_2                      0xf
#define IRQ_PRIO_3                      0xf
#define IRQ_PRIO_4                      0xf
#define IRQ_PRIO_5                      0xf
#define IRQ_PRIO_6                      0xf
#define IRQ_PRIO_7                      0xf
#define IRQ_PRIO_8                      0xf
#define IRQ_PRIO_9                      0xf
#define IRQ_PRIO_10                     0xf
#define IRQ_PRIO_11                     0xf
#define IRQ_PRIO_12                     0xf
#define IRQ_PRIO_13                     0xf
#define IRQ_PRIO_14                     0xf
#define IRQ_PRIO_15                     0xf
#define IRQ_PRIO_16                     0xf
#define IRQ_PRIO_17                     0xf
#define IRQ_PRIO_18                     0xf
#define IRQ_PRIO_19                     0xf
#define IRQ_PRIO_20                     0xf
#define IRQ_PRIO_21                     0xf
#define IRQ_PRIO_22                     0xf
#define IRQ_PRIO_23                     0xf
#define IRQ_PRIO_24                     0xf
#define IRQ_PRIO_25                     0xf
#define IRQ_PRIO_26                     0xf
#define IRQ_PRIO_27                     0xf
#define IRQ_PRIO_28                     0xf
#define IRQ_PRIO_29                     0xf
#define IRQ_PRIO_30                     0xf
#define IRQ_PRIO_31                     0xf

#endif				/* __ASM_ARCH_MB86HXX_VIC_H */
