/*
 * Copyright (C) 2009 by FUJITSU MICROELECTRONICS LIMITED
 * Copyright (C) 2010 by FUJITSU SEMICONDUCTOR LIMITED
 *
 * The Inventra Controller Driver for Linux is free software; you
 * can redistribute it and/or modify it under the terms of the GNU
 * General Public License version 2 as published by the Free Software
 * Foundation.
 */

#ifndef __MUSB_MB86HXX_H__
#define __MUSB_MB86HXX_H__

#include <mach/hardware.h>

#define mb86hxx_readb(a)          ioread8(IO_ADDRESS(a))
#define mb86hxx_writeb(v,a)       iowrite8(v,IO_ADDRESS(a))
#define mb86hxx_readl(a)          ioread32(IO_ADDRESS(a))
#define mb86hxx_writel(v,a)       iowrite32(v,IO_ADDRESS(a))

#ifdef CONFIG_MACH_FUJITSU_TVSTBSOC /* MB86H60 */
#define MB86HXX_USB_MODE	(MB86HXX_DMA_BASE + (0x14))
#define MB86HXX_USB_INT_MASK	(MB86HXX_DMA_BASE + (0xf0))
#define MB86HXX_USB_INT_STATUS	(MB86HXX_DMA_BASE + (0xf4))
#define MB86HXX_USB_INT_CLEAR	(MB86HXX_DMA_BASE + (0xf8))
#endif

#ifdef CONFIG_MACH_FUJITSU_TVSTBSOC1 /* MB86H61 */
#define MB86HXX_USB0_INT_MASK	(MB86HXX_DMA_BASE + (0xf0))
#define MB86HXX_USB0_INT_STATUS	(MB86HXX_DMA_BASE + (0xf4))
#define MB86HXX_USB0_INT_CLEAR	(MB86HXX_DMA_BASE + (0xf8))

#define MB86HXX_USB0_EARLY		(MB86HXX_DMA_BASE + (0x38))
#define MB86HXX_USB0_MODE		(MB86HXX_DMA_BASE + (0x3c))
#define MB86HXX_USB0_PHY_CFG	(MB86HXX_DMA_BASE + (0x40))

#define MB86HXX_USB1_INT_MASK	(MB86HXX_DMA_BASE + (0xb0))
#define MB86HXX_USB1_INT_STATUS	(MB86HXX_DMA_BASE + (0xb4))
#define MB86HXX_USB1_INT_CLEAR	(MB86HXX_DMA_BASE + (0xb8))

#define MB86HXX_USB1_EARLY		(MB86HXX_DMA_BASE + (0x48))
#define MB86HXX_USB1_MODE		(MB86HXX_DMA_BASE + (0x4c))
#define MB86HXX_USB1_PHY_CFG	(MB86HXX_DMA_BASE + (0x50))

#define MB86HXX_USB_CLK_CTL		(MB86HXX_CLKPWR_BASE + (0x30))
#define MB86HXX_CLKPWR_CONFIGDMAC	(MB86HXX_CLKPWR_BASE + (0x74))
#define MB86HXX_CLKPWR_CONFIGDMAC_RESET	(MB86HXX_CLKPWR_BASE + (0x80))

#define MB86HXX_USB_BASE_MASK	(0xfffff000)
#define MB86HXX_USB_UTMI_FS		(0x80)
#define MB86HXX_USB_PHY0_RESET	(2)
#define MB86HXX_USB_PHY1_RESET	(4)
#define MB86HXX_CLK_EN_CFG9		(25)
#define MB86HXX_CLK_RESET_N9	(9)
#endif

#define MB86HXX_USB_1BYTE_ACCESS	(0)
#define MB86HXX_USB_2BYTE_ACCESS	(1)
#define MB86HXX_USB_4BYTE_ACCESS	(2)
#define MB86HXX_USB_LENGTH_MASK		(6)

#endif	/* __MUSB_MB86HXX_H__ */
